blob: 8bc4151941155160202468ad4945f541e573c71d [file] [log] [blame]
jeffhao5d1ac922011-09-29 17:41:15 -07001#!/bin/bash
2#
3# Copyright (C) 2007 The Android Open Source Project
4#
5# Licensed under the Apache License, Version 2.0 (the "License");
6# you may not use this file except in compliance with the License.
7# You may obtain a copy of the License at
8#
9# http://www.apache.org/licenses/LICENSE-2.0
10#
11# Unless required by applicable law or agreed to in writing, software
12# distributed under the License is distributed on an "AS IS" BASIS,
13# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
14# See the License for the specific language governing permissions and
15# limitations under the License.
16
17# Set up prog to be the path of this script, including following symlinks,
18# and set up progdir to be the fully-qualified pathname of its directory.
19prog="$0"
Andreas Gampedeb48a02014-10-22 00:44:35 -070020args="$@"
jeffhao5d1ac922011-09-29 17:41:15 -070021while [ -h "${prog}" ]; do
22 newProg=`/bin/ls -ld "${prog}"`
23 newProg=`expr "${newProg}" : ".* -> \(.*\)$"`
24 if expr "x${newProg}" : 'x/' >/dev/null; then
25 prog="${newProg}"
26 else
27 progdir=`dirname "${prog}"`
28 prog="${progdir}/${newProg}"
29 fi
30done
31oldwd=`pwd`
32progdir=`dirname "${prog}"`
33cd "${progdir}"
34progdir=`pwd`
35prog="${progdir}"/`basename "${prog}"`
Brian Carlstrom105215d2012-06-14 12:50:44 -070036test_dir="test-$$"
Andreas Gampe5a79fde2014-08-06 13:12:26 -070037if [ -z "$TMPDIR" ]; then
38 tmp_dir="/tmp/$USER/${test_dir}"
39else
40 tmp_dir="${TMPDIR}/$USER/${test_dir}"
41fi
David Brazdil4846d132015-01-15 19:07:08 +000042checker="${progdir}/../tools/checker.py"
jeffhao5d1ac922011-09-29 17:41:15 -070043
44export JAVA="java"
Brian Carlstrom5103ce62014-03-30 16:17:42 -070045export JAVAC="javac -g"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +010046export RUN="${progdir}/etc/run-test-jar"
Brian Carlstrom105215d2012-06-14 12:50:44 -070047export DEX_LOCATION=/data/run-test/${test_dir}
Elliott Hughesc717eef2012-06-15 16:01:26 -070048export NEED_DEX="true"
jeffhao5d1ac922011-09-29 17:41:15 -070049
Tsu Chiang Chuang4407e612012-07-19 16:13:43 -070050# If dx was not set by the environment variable, assume it is in the path.
51if [ -z "$DX" ]; then
52 export DX="dx"
53fi
54
Tsu Chiang Chuang6674f8a2013-01-16 15:41:21 -080055# If jasmin was not set by the environment variable, assume it is in the path.
56if [ -z "$JASMIN" ]; then
57 export JASMIN="jasmin"
58fi
59
Andreas Gampe8fda9f22014-10-03 16:15:37 -070060# If smali was not set by the environment variable, assume it is in the path.
61if [ -z "$SMALI" ]; then
62 export SMALI="smali"
63fi
64
65# If dexmerger was not set by the environment variable, assume it is in the path.
66if [ -z "$DXMERGER" ]; then
67 export DXMERGER="dexmerger"
68fi
69
Tsu Chiang Chuang6674f8a2013-01-16 15:41:21 -080070
jeffhao5d1ac922011-09-29 17:41:15 -070071info="info.txt"
72build="build"
73run="run"
74expected="expected.txt"
Andreas Gampe1c83cbc2014-07-22 18:52:29 -070075check_cmd="check"
jeffhao5d1ac922011-09-29 17:41:15 -070076output="output.txt"
77build_output="build-output.txt"
David Brazdil4846d132015-01-15 19:07:08 +000078cfg_output="cfg-output.txt"
Brian Carlstromdc959ea2013-10-28 00:44:49 -070079lib="libartd.so"
jeffhao5d1ac922011-09-29 17:41:15 -070080run_args="--quiet"
David Brazdil4846d132015-01-15 19:07:08 +000081build_args=""
jeffhao5d1ac922011-09-29 17:41:15 -070082
Alex Light9d722532014-07-22 18:07:12 -070083prebuild_mode="yes"
Brian Carlstrom2613de42012-06-15 17:37:16 -070084target_mode="yes"
jeffhao5d1ac922011-09-29 17:41:15 -070085dev_mode="no"
86update_mode="no"
Alex Lighta59dd802014-07-02 16:28:08 -070087debug_mode="no"
88relocate="yes"
Jeff Hao201803f2013-11-20 18:11:39 -080089runtime="art"
jeffhao5d1ac922011-09-29 17:41:15 -070090usage="no"
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -070091build_only="no"
Andreas Gampe2fe07922014-04-21 07:50:39 -070092suffix64=""
Jeff Hao85139a32014-07-23 11:52:52 -070093trace="false"
Alex Lighte7873ec2014-08-12 09:53:50 -070094basic_verify="false"
95gc_verify="false"
96gc_stress="false"
Alex Lightbfac14a2014-07-30 09:41:21 -070097always_clean="no"
Alex Light03a112d2014-08-25 13:25:56 -070098have_dex2oat="yes"
99have_patchoat="yes"
100have_image="yes"
Andreas Gampe63fc30e2014-10-24 21:58:16 -0700101image_suffix=""
Andreas Gampec23c9c92014-10-28 14:47:25 -0700102pic_image_suffix=""
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000103android_root="/system"
jeffhao5d1ac922011-09-29 17:41:15 -0700104
105while true; do
106 if [ "x$1" = "x--host" ]; then
Brian Carlstrom2613de42012-06-15 17:37:16 -0700107 target_mode="no"
TDYa127b92bcab2012-04-08 00:09:51 -0700108 DEX_LOCATION=$tmp_dir
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100109 run_args="${run_args} --host"
jeffhao5d1ac922011-09-29 17:41:15 -0700110 shift
Elliott Hughes58bcc402012-02-14 14:10:10 -0800111 elif [ "x$1" = "x--jvm" ]; then
Brian Carlstrom2613de42012-06-15 17:37:16 -0700112 target_mode="no"
Jeff Hao201803f2013-11-20 18:11:39 -0800113 runtime="jvm"
Brian Carlstrom01afdba2014-10-03 10:28:47 -0700114 prebuild_mode="no"
Elliott Hughesc717eef2012-06-15 16:01:26 -0700115 NEED_DEX="false"
Nicolas Geoffray288a4a22014-10-07 11:02:40 +0100116 run_args="${run_args} --jvm"
jeffhao5d1ac922011-09-29 17:41:15 -0700117 shift
Elliott Hughes58bcc402012-02-14 14:10:10 -0800118 elif [ "x$1" = "x-O" ]; then
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700119 lib="libart.so"
120 shift
121 elif [ "x$1" = "x--dalvik" ]; then
122 lib="libdvm.so"
Jeff Hao201803f2013-11-20 18:11:39 -0800123 runtime="dalvik"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700124 shift
Alex Light03a112d2014-08-25 13:25:56 -0700125 elif [ "x$1" = "x--no-dex2oat" ]; then
126 have_dex2oat="no"
127 shift
128 elif [ "x$1" = "x--no-patchoat" ]; then
129 have_patchoat="no"
130 shift
131 elif [ "x$1" = "x--no-image" ]; then
132 have_image="no"
133 shift
Andreas Gampec23c9c92014-10-28 14:47:25 -0700134 elif [ "x$1" = "x--pic-image" ]; then
135 pic_image_suffix="-pic"
136 shift
137 elif [ "x$1" = "x--pic-test" ]; then
138 run_args="${run_args} --pic-test"
139 shift
Alex Lighta59dd802014-07-02 16:28:08 -0700140 elif [ "x$1" = "x--relocate" ]; then
141 relocate="yes"
142 shift
143 elif [ "x$1" = "x--no-relocate" ]; then
144 relocate="no"
145 shift
146 elif [ "x$1" = "x--prebuild" ]; then
Nicolas Geoffray5fd18ba2014-10-03 12:08:38 +0100147 run_args="${run_args} --prebuild"
Alex Lighta59dd802014-07-02 16:28:08 -0700148 prebuild_mode="yes"
149 shift;
150 elif [ "x$1" = "x--no-prebuild" ]; then
Nicolas Geoffray5fd18ba2014-10-03 12:08:38 +0100151 run_args="${run_args} --no-prebuild"
Alex Lighta59dd802014-07-02 16:28:08 -0700152 prebuild_mode="no"
153 shift;
Alex Lighte7873ec2014-08-12 09:53:50 -0700154 elif [ "x$1" = "x--gcverify" ]; then
155 basic_verify="true"
156 gc_verify="true"
157 shift
158 elif [ "x$1" = "x--gcstress" ]; then
159 basic_verify="true"
160 gc_stress="true"
161 shift
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700162 elif [ "x$1" = "x--image" ]; then
163 shift
164 image="$1"
165 run_args="${run_args} --image $image"
Elliott Hughes7c046102011-10-19 18:16:03 -0700166 shift
Nicolas Geoffray92cf83e2014-03-18 17:59:20 +0000167 elif [ "x$1" = "x-Xcompiler-option" ]; then
168 shift
169 option="$1"
170 run_args="${run_args} -Xcompiler-option $option"
171 shift
Mathieu Chartier769a5ad2014-05-18 15:30:10 -0700172 elif [ "x$1" = "x--runtime-option" ]; then
173 shift
174 option="$1"
175 run_args="${run_args} --runtime-option $option"
176 shift
Mathieu Chartierc0a8a802014-10-17 15:58:01 -0700177 elif [ "x$1" = "x--gdb-arg" ]; then
178 shift
179 gdb_arg="$1"
180 run_args="${run_args} --gdb-arg $gdb_arg"
181 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700182 elif [ "x$1" = "x--debug" ]; then
183 run_args="${run_args} --debug"
184 shift
185 elif [ "x$1" = "x--gdb" ]; then
186 run_args="${run_args} --gdb"
187 dev_mode="yes"
188 shift
189 elif [ "x$1" = "x--zygote" ]; then
190 run_args="${run_args} --zygote"
191 shift
jeffhao0dff3f42012-11-20 15:13:43 -0800192 elif [ "x$1" = "x--interpreter" ]; then
193 run_args="${run_args} --interpreter"
Andreas Gampe63fc30e2014-10-24 21:58:16 -0700194 image_suffix="-interpreter"
195 shift
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800196 elif [ "x$1" = "x--jit" ]; then
197 run_args="${run_args} --jit"
198 shift
Andreas Gampe63fc30e2014-10-24 21:58:16 -0700199 elif [ "x$1" = "x--optimizing" ]; then
200 run_args="${run_args} -Xcompiler-option --compiler-backend=Optimizing"
201 image_suffix="-optimizing"
jeffhao0dff3f42012-11-20 15:13:43 -0800202 shift
Nicolas Geoffrayc9338b92014-12-03 13:36:10 +0000203 elif [ "x$1" = "x--quick" ]; then
204 run_args="${run_args} -Xcompiler-option --compiler-backend=Quick"
205 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700206 elif [ "x$1" = "x--no-verify" ]; then
207 run_args="${run_args} --no-verify"
208 shift
209 elif [ "x$1" = "x--no-optimize" ]; then
210 run_args="${run_args} --no-optimize"
211 shift
212 elif [ "x$1" = "x--no-precise" ]; then
213 run_args="${run_args} --no-precise"
214 shift
Elliott Hughes7c046102011-10-19 18:16:03 -0700215 elif [ "x$1" = "x--invoke-with" ]; then
216 shift
217 what="$1"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700218 if [ "x$what" = "x" ]; then
219 echo "$0 missing argument to --invoke-with" 1>&2
220 usage="yes"
221 break
222 fi
Ian Rogers0e033672013-04-19 10:22:46 -0700223 run_args="${run_args} --invoke-with ${what}"
jeffhao5d1ac922011-09-29 17:41:15 -0700224 shift
225 elif [ "x$1" = "x--dev" ]; then
226 run_args="${run_args} --dev"
227 dev_mode="yes"
228 shift
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700229 elif [ "x$1" = "x--build-only" ]; then
230 build_only="yes"
231 shift
232 elif [ "x$1" = "x--output-path" ]; then
233 shift
234 tmp_dir=$1
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700235 if [ "x$tmp_dir" = "x" ]; then
236 echo "$0 missing argument to --output-path" 1>&2
237 usage="yes"
238 break
239 fi
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700240 shift
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000241 elif [ "x$1" = "x--android-root" ]; then
242 shift
243 if [ "x$1" = "x" ]; then
244 echo "$0 missing argument to --android-root" 1>&2
245 usage="yes"
246 break
247 fi
248 android_root="$1"
249 run_args="${run_args} --android-root $1"
250 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700251 elif [ "x$1" = "x--update" ]; then
252 update_mode="yes"
253 shift
254 elif [ "x$1" = "x--help" ]; then
255 usage="yes"
256 shift
Andreas Gampeafbaa1a2014-03-25 18:09:32 -0700257 elif [ "x$1" = "x--64" ]; then
258 run_args="${run_args} --64"
Andreas Gampe2fe07922014-04-21 07:50:39 -0700259 suffix64="64"
Andreas Gampeafbaa1a2014-03-25 18:09:32 -0700260 shift
Sebastien Hertz07aaac82014-07-09 15:59:05 +0200261 elif [ "x$1" = "x--trace" ]; then
Jeff Hao85139a32014-07-23 11:52:52 -0700262 trace="true"
Sebastien Hertz07aaac82014-07-09 15:59:05 +0200263 shift
Alex Lightbfac14a2014-07-30 09:41:21 -0700264 elif [ "x$1" = "x--always-clean" ]; then
265 always_clean="yes"
266 shift
Andreas Gampee21dc3d2014-12-08 16:59:43 -0800267 elif [ "x$1" = "x--dex2oat-swap" ]; then
268 run_args="${run_args} --dex2oat-swap"
269 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700270 elif expr "x$1" : "x--" >/dev/null 2>&1; then
Elliott Hughes7c046102011-10-19 18:16:03 -0700271 echo "unknown $0 option: $1" 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700272 usage="yes"
273 break
274 else
275 break
276 fi
277done
Andreas Gampe3a12cfe2014-08-13 15:40:22 -0700278
279# tmp_dir may be relative, resolve.
280#
281# Cannot use realpath, as it does not exist on Mac.
282# Cannot us a simple "cd", as the path might not be created yet.
Brian Carlstromc580e042014-09-08 21:37:39 -0700283# Cannot use readlink -m, as it does not exist on Mac.
284# Fallback to nuclear option:
Andreas Gampe907b6992014-08-18 22:26:49 -0700285noncanonical_tmp_dir=$tmp_dir
Brian Carlstromc580e042014-09-08 21:37:39 -0700286tmp_dir="`cd $oldwd ; python -c "import os; print os.path.realpath('$tmp_dir')"`"
Dmitry Petrochenko81c56e72014-03-05 15:05:46 +0700287mkdir -p $tmp_dir
jeffhao5d1ac922011-09-29 17:41:15 -0700288
Alex Lighte7873ec2014-08-12 09:53:50 -0700289if [ "$basic_verify" = "true" ]; then
Hiroshi Yamauchi312baf12015-01-12 12:11:05 -0800290 # Set HspaceCompactForOOMMinIntervalMs to zero to run hspace compaction for OOM more frequently in tests.
291 run_args="${run_args} --runtime-option -Xgc:preverify --runtime-option -Xgc:postverify --runtime-option -XX:HspaceCompactForOOMMinIntervalMs=0"
Alex Lighte7873ec2014-08-12 09:53:50 -0700292fi
293if [ "$gc_verify" = "true" ]; then
294 run_args="${run_args} --runtime-option -Xgc:preverify_rosalloc --runtime-option -Xgc:postverify_rosalloc"
295fi
296if [ "$gc_stress" = "true" ]; then
297 run_args="${run_args} --runtime-option -Xgc:SS --runtime-option -Xms2m --runtime-option -Xmx2m"
298fi
Jeff Hao85139a32014-07-23 11:52:52 -0700299if [ "$trace" = "true" ]; then
300 run_args="${run_args} --runtime-option -Xmethod-trace --runtime-option -Xmethod-trace-file:${DEX_LOCATION}/trace.bin --runtime-option -Xmethod-trace-file-size:2000000"
301fi
302
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700303# Most interesting target architecture variables are Makefile variables, not environment variables.
Nicolas Geoffray6fbcc122014-07-24 00:36:48 +0100304# Try to map the suffix64 flag and what we find in ${ANDROID_PRODUCT_OUT}/data/art-test to an architecture name.
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700305function guess_arch_name() {
Nicolas Geoffray6fbcc122014-07-24 00:36:48 +0100306 grep32bit=`ls ${ANDROID_PRODUCT_OUT}/data/art-test | grep -E '^(arm|x86|mips)$'`
Andreas Gampe1a5c4062015-01-15 12:10:47 -0800307 grep64bit=`ls ${ANDROID_PRODUCT_OUT}/data/art-test | grep -E '^(arm64|x86_64|mips64)$'`
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700308 if [ "x${suffix64}" = "x64" ]; then
309 target_arch_name=${grep64bit}
310 else
311 target_arch_name=${grep32bit}
312 fi
313}
314
Alex Lighta59dd802014-07-02 16:28:08 -0700315if [ "$target_mode" = "no" ]; then
316 if [ "$runtime" = "jvm" ]; then
Alex Lighta59dd802014-07-02 16:28:08 -0700317 if [ "$prebuild_mode" = "yes" ]; then
318 echo "--prebuild with --jvm is unsupported";
319 exit 1;
320 fi
Alex Lighta59dd802014-07-02 16:28:08 -0700321 fi
322fi
323
Alex Light03a112d2014-08-25 13:25:56 -0700324if [ "$have_patchoat" = "no" ]; then
325 run_args="${run_args} --no-patchoat"
326fi
327
328if [ "$have_dex2oat" = "no" ]; then
329 run_args="${run_args} --no-dex2oat"
330fi
331
Jeff Hao201803f2013-11-20 18:11:39 -0800332if [ ! "$runtime" = "jvm" ]; then
333 run_args="${run_args} --lib $lib"
334fi
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700335
Jeff Hao201803f2013-11-20 18:11:39 -0800336if [ "$runtime" = "dalvik" ]; then
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700337 if [ "$target_mode" = "no" ]; then
Nicolas Geoffray6fbcc122014-07-24 00:36:48 +0100338 framework="${ANDROID_PRODUCT_OUT}/system/framework"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700339 bpath="${framework}/core.jar:${framework}/conscrypt.jar:${framework}/okhttp.jar:${framework}/core-junit.jar:${framework}/bouncycastle.jar:${framework}/ext.jar"
340 run_args="${run_args} --boot -Xbootclasspath:${bpath}"
341 else
342 true # defaults to using target BOOTCLASSPATH
343 fi
Jeff Hao201803f2013-11-20 18:11:39 -0800344elif [ "$runtime" = "art" ]; then
345 if [ "$target_mode" = "no" ]; then
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100346 # ANDROID_BUILD_TOP and ANDROID_HOST_OUT are not set in a build environment.
Brian Carlstrom43534862014-02-19 01:13:52 -0800347 if [ -z "$ANDROID_BUILD_TOP" ]; then
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100348 export ANDROID_BUILD_TOP=$oldwd
Brian Carlstrom43534862014-02-19 01:13:52 -0800349 fi
350 if [ -z "$ANDROID_HOST_OUT" ]; then
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100351 export ANDROID_HOST_OUT=$ANDROID_BUILD_TOP/out/host/linux-x86
Brian Carlstrom43534862014-02-19 01:13:52 -0800352 fi
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000353 run_args="${run_args} --boot ${ANDROID_HOST_OUT}/framework/core${image_suffix}${pic_image_suffix}.art"
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700354 run_args="${run_args} --runtime-option -Djava.library.path=${ANDROID_HOST_OUT}/lib${suffix64}"
Jeff Hao201803f2013-11-20 18:11:39 -0800355 else
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700356 guess_arch_name
357 run_args="${run_args} --runtime-option -Djava.library.path=/data/art-test/${target_arch_name}"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000358 run_args="${run_args} --boot /data/art-test/core${image_suffix}${pic_image_suffix}.art"
Jeff Hao201803f2013-11-20 18:11:39 -0800359 fi
Alex Lighta59dd802014-07-02 16:28:08 -0700360 if [ "$relocate" = "yes" ]; then
361 run_args="${run_args} --relocate"
362 else
363 run_args="${run_args} --no-relocate"
364 fi
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700365fi
366
Alex Light03a112d2014-08-25 13:25:56 -0700367if [ "$have_image" = "no" ]; then
Alex Light1ef4ce82014-08-27 11:13:47 -0700368 if [ "$runtime" != "art" ]; then
369 echo "--no-image is only supported on the art runtime"
370 exit 1
371 fi
372 if [ "$target_mode" = "no" ]; then
373 framework="${ANDROID_HOST_OUT}/framework"
374 bpath_suffix="-hostdex"
375 else
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000376 framework="${android_root}/framework"
Alex Light1ef4ce82014-08-27 11:13:47 -0700377 bpath_suffix=""
378 fi
379 # TODO If the target was compiled WITH_DEXPREOPT=true then these tests will
380 # fail since these jar files will be stripped.
381 bpath="${framework}/core-libart${bpath_suffix}.jar"
382 bpath="${bpath}:${framework}/conscrypt${bpath_suffix}.jar"
383 bpath="${bpath}:${framework}/okhttp${bpath_suffix}.jar"
384 bpath="${bpath}:${framework}/core-junit${bpath_suffix}.jar"
385 bpath="${bpath}:${framework}/bouncycastle${bpath_suffix}.jar"
386 # Pass down the bootclasspath
387 run_args="${run_args} --runtime-option -Xbootclasspath:${bpath}"
Alex Light03a112d2014-08-25 13:25:56 -0700388 run_args="${run_args} --no-image"
389fi
390
jeffhao5d1ac922011-09-29 17:41:15 -0700391if [ "$dev_mode" = "yes" -a "$update_mode" = "yes" ]; then
392 echo "--dev and --update are mutually exclusive" 1>&2
393 usage="yes"
394fi
395
396if [ "$usage" = "no" ]; then
397 if [ "x$1" = "x" -o "x$1" = "x-" ]; then
398 test_dir=`basename "$oldwd"`
399 else
400 test_dir="$1"
401 fi
402
403 if [ '!' -d "$test_dir" ]; then
404 td2=`echo ${test_dir}-*`
405 if [ '!' -d "$td2" ]; then
406 echo "${test_dir}: no such test directory" 1>&2
407 usage="yes"
408 fi
409 test_dir="$td2"
410 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700411 # Shift to get rid of the test name argument. The rest of the arguments
412 # will get passed to the test run.
413 shift
414fi
415
416if [ "$usage" = "yes" ]; then
417 prog=`basename $prog`
418 (
419 echo "usage:"
420 echo " $prog --help Print this message."
421 echo " $prog [options] [test-name] Run test normally."
422 echo " $prog --dev [options] [test-name] Development mode" \
423 "(dumps to stdout)."
424 echo " $prog --update [options] [test-name] Update mode" \
425 "(replaces expected.txt)."
426 echo ' Omitting the test name or specifying "-" will use the' \
427 "current directory."
428 echo " Runtime Options:"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000429 echo " -O Run non-debug rather than debug build (off by default)."
430 echo " -Xcompiler-option Pass an option to the compiler."
431 echo " --runtime-option Pass an option to the runtime."
432 echo " --debug Wait for a debugger to attach."
433 echo " --gdb Run under gdb; incompatible with some tests."
434 echo " --build-only Build test files only (off by default)."
435 echo " --interpreter Enable interpreter only mode (off by default)."
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800436 echo " --jit Enable jit (off by default)."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000437 echo " --optimizing Enable optimizing compiler (off by default)."
Nicolas Geoffrayc9338b92014-12-03 13:36:10 +0000438 echo " --quick Use Quick compiler (default)."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000439 echo " --no-verify Turn off verification (on by default)."
440 echo " --no-optimize Turn off optimization (on by default)."
441 echo " --no-precise Turn off precise GC (on by default)."
442 echo " --zygote Spawn the process from the Zygote." \
jeffhao5d1ac922011-09-29 17:41:15 -0700443 "If used, then the"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000444 echo " other runtime options are ignored."
445 echo " --no-dex2oat Run as though dex2oat was failing."
446 echo " --no-patchoat Run as though patchoat was failing."
447 echo " --prebuild Run dex2oat on the files before starting test. (default)"
448 echo " --no-prebuild Do not run dex2oat on the files before starting"
449 echo " the test."
450 echo " --relocate Force the use of relocating in the test, making"
451 echo " the image and oat files be relocated to a random"
452 echo " address before running. (default)"
453 echo " --no-relocate Force the use of no relocating in the test"
454 echo " --host Use the host-mode virtual machine."
455 echo " --invoke-with Pass --invoke-with option to runtime."
456 echo " --dalvik Use Dalvik (off by default)."
457 echo " --jvm Use a host-local RI virtual machine."
458 echo " --output-path [path] Location where to store the build" \
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700459 "files."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000460 echo " --64 Run the test in 64-bit mode"
461 echo " --trace Run with method tracing"
462 echo " --gcstress Run with gc stress testing"
463 echo " --gcverify Run with gc verification"
464 echo " --always-clean Delete the test files even if the test fails."
465 echo " --android-root [path] The path on target for the android root. (/system by default)."
Andreas Gampee21dc3d2014-12-08 16:59:43 -0800466 echo " --dex2oat-swap Use a dex2oat swap file."
jeffhao5d1ac922011-09-29 17:41:15 -0700467 ) 1>&2
468 exit 1
469fi
470
471cd "$test_dir"
472test_dir=`pwd`
473
474td_info="${test_dir}/${info}"
475td_expected="${test_dir}/${expected}"
476
Brian Carlstrom22469aa2012-09-07 10:34:57 -0700477if [ ! -r $td_info ]; then
478 echo "${test_dir}: missing file $td_info" 1>&2
479 exit 1
480fi
481
482if [ ! -r $td_expected ]; then
483 echo "${test_dir}: missing file $td_expected" 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700484 exit 1
485fi
486
487# copy the test to a temp dir and run it
488
Elliott Hughes510c8782011-10-06 10:57:34 -0700489echo "${test_dir}: building..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700490
491rm -rf "$tmp_dir"
492cp -Rp "$test_dir" "$tmp_dir"
493cd "$tmp_dir"
494
495if [ '!' -r "$build" ]; then
496 cp "${progdir}/etc/default-build" build
497fi
498
499if [ '!' -r "$run" ]; then
500 cp "${progdir}/etc/default-run" run
501fi
502
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700503if [ '!' -r "$check_cmd" ]; then
504 cp "${progdir}/etc/default-check" check
505fi
506
jeffhao5d1ac922011-09-29 17:41:15 -0700507chmod 755 "$build"
508chmod 755 "$run"
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700509chmod 755 "$check_cmd"
jeffhao5d1ac922011-09-29 17:41:15 -0700510
Elliott Hughes8cbc8bc2011-10-04 11:19:45 -0700511export TEST_NAME=`basename ${test_dir}`
512
David Brazdil4846d132015-01-15 19:07:08 +0000513# Tests named '<number>-checker-*' will also have their CFGs verified with
514# Checker when compiled with Optimizing on host.
515if [[ "$TEST_NAME" =~ ^[0-9]+-checker- ]]; then
516 # Build Checker DEX files without dx's optimizations so the input to dex2oat
517 # better resembles the Java source. We always build the DEX the same way, even
518 # if Checker is not invoked and the test only runs the program.
519 build_args="${build_args} --dx-option --no-optimize"
520
521 if [ "$runtime" = "art" -a "$image_suffix" = "-optimizing" -a "$target_mode" = "no" ]; then
522 run_checker="yes"
523 run_args="${run_args} -Xcompiler-option --dump-cfg=$tmp_dir/$cfg_output \
524 -Xcompiler-option -j1"
525 fi
526fi
527
Ian Rogers997f0f92014-06-21 22:58:05 -0700528# To cause tests to fail fast, limit the file sizes created by dx, dex2oat and ART output to 2MB.
529file_size_limit=2048
530if echo "$test_dir" | grep 089; then
531 file_size_limit=5120
532elif echo "$test_dir" | grep 083; then
533 file_size_limit=5120
534fi
Alex Lighta59dd802014-07-02 16:28:08 -0700535if ! ulimit -S "$file_size_limit"; then
Ian Rogers997f0f92014-06-21 22:58:05 -0700536 echo "ulimit file size setting failed"
537fi
538
jeffhao5d1ac922011-09-29 17:41:15 -0700539good="no"
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000540good_build="yes"
541good_run="yes"
jeffhao5d1ac922011-09-29 17:41:15 -0700542if [ "$dev_mode" = "yes" ]; then
David Brazdil4846d132015-01-15 19:07:08 +0000543 "./${build}" $build_args 2>&1
Elliott Hughes7ab3a2a2012-06-18 16:34:20 -0700544 build_exit="$?"
545 echo "build exit status: $build_exit" 1>&2
546 if [ "$build_exit" = '0' ]; then
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800547 echo "${test_dir}: running..." 1>&2
548 "./${run}" $run_args "$@" 2>&1
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700549 run_exit="$?"
Calin Juravle3cf48772015-01-26 16:47:33 +0000550
Brian Carlstrom700c8d32012-11-05 10:42:02 -0800551 if [ "$run_exit" = "0" ]; then
Calin Juravle3cf48772015-01-26 16:47:33 +0000552 if [ "$run_checker" = "yes" ]; then
553 "$checker" "$cfg_output" "$tmp_dir" 2>&1
554 checker_exit="$?"
555 if [ "$checker_exit" = "0" ]; then
556 good="yes"
557 fi
558 echo "checker exit status: $checker_exit" 1>&2
559 else
560 good="yes"
561 fi
Brian Carlstrom700c8d32012-11-05 10:42:02 -0800562 fi
Calin Juravle3cf48772015-01-26 16:47:33 +0000563 echo "run exit status: $run_exit" 1>&2
Elliott Hughes7ab3a2a2012-06-18 16:34:20 -0700564 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700565elif [ "$update_mode" = "yes" ]; then
David Brazdil4846d132015-01-15 19:07:08 +0000566 "./${build}" $build_args >"$build_output" 2>&1
jeffhao5d1ac922011-09-29 17:41:15 -0700567 build_exit="$?"
568 if [ "$build_exit" = '0' ]; then
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800569 echo "${test_dir}: running..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700570 "./${run}" $run_args "$@" >"$output" 2>&1
David Brazdil4846d132015-01-15 19:07:08 +0000571 if [ "$run_checker" = "yes" ]; then
572 "$checker" -q "$cfg_output" "$tmp_dir" >> "$output" 2>&1
573 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700574 sed -e 's/[[:cntrl:]]$//g' < "$output" >"${td_expected}"
575 good="yes"
576 else
577 cat "$build_output" 1>&2
578 echo "build exit status: $build_exit" 1>&2
579 fi
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700580elif [ "$build_only" = "yes" ]; then
581 good="yes"
David Brazdil4846d132015-01-15 19:07:08 +0000582 "./${build}" $build_args >"$build_output" 2>&1
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700583 build_exit="$?"
584 if [ "$build_exit" '!=' '0' ]; then
585 cp "$build_output" "$output"
586 echo "build exit status: $build_exit" >>"$output"
587 diff --strip-trailing-cr -q "$expected" "$output" >/dev/null
588 if [ "$?" '!=' "0" ]; then
589 good="no"
590 echo "BUILD FAILED For ${TEST_NAME}"
591 fi
592 fi
Tsu Chiang Chuang379e2f52013-08-20 12:24:52 -0700593 # Clean up extraneous files that are not used by tests.
Tsu Chiang Chuang0160d992013-09-13 14:17:42 -0700594 find $tmp_dir -mindepth 1 ! -regex ".*/\(.*jar\|$output\|$expected\)" | xargs rm -rf
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700595 exit 0
jeffhao5d1ac922011-09-29 17:41:15 -0700596else
David Brazdil4846d132015-01-15 19:07:08 +0000597 "./${build}" $build_args >"$build_output" 2>&1
jeffhao5d1ac922011-09-29 17:41:15 -0700598 build_exit="$?"
599 if [ "$build_exit" = '0' ]; then
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800600 echo "${test_dir}: running..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700601 "./${run}" $run_args "$@" >"$output" 2>&1
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000602 run_exit="$?"
603 if [ "$run_exit" != "0" ]; then
604 echo "run exit status: $run_exit" 1>&2
605 good_run="no"
David Brazdil4846d132015-01-15 19:07:08 +0000606 elif [ "$run_checker" = "yes" ]; then
607 "$checker" -q "$cfg_output" "$tmp_dir" >> "$output" 2>&1
608 checker_exit="$?"
609 if [ "$checker_exit" != "0" ]; then
610 echo "checker exit status: $checker_exit" 1>&2
611 good_run="no"
612 else
613 good_run="yes"
614 fi
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000615 else
616 good_run="yes"
617 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700618 else
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000619 good_build="no"
jeffhao5d1ac922011-09-29 17:41:15 -0700620 cp "$build_output" "$output"
Andreas Gampef6930a82014-10-21 09:33:08 -0700621 echo "Failed to build in tmpdir=${tmp_dir} from oldwd=${oldwd} and cwd=`pwd`" >> "$output"
622 echo "Non-canonical tmpdir was ${noncanonical_tmp_dir}" >> "$output"
Ian Rogersd9ad27d2014-10-27 13:48:21 -0700623 echo "Args: ${args}" >> "$output"
Andreas Gampef6930a82014-10-21 09:33:08 -0700624 echo "build exit status: $build_exit" >> "$output"
Andreas Gampe5c114902014-10-27 17:03:58 -0700625 max_name_length=$(getconf NAME_MAX ${tmp_dir})
626 echo "Max filename (NAME_MAX): ${max_name_length}" >> "$output"
627 max_path_length=$(getconf PATH_MAX ${tmp_dir})
Andreas Gampe602fbcd2014-10-27 17:06:29 -0700628 echo "Max pathlength (PATH_MAX): ${max_path_length}" >> "$output"
jeffhao5d1ac922011-09-29 17:41:15 -0700629 fi
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700630 ./$check_cmd "$expected" "$output"
jeffhao5d1ac922011-09-29 17:41:15 -0700631 if [ "$?" = "0" ]; then
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000632 if [ "$good_build" = "no" -o "$good_run" = "yes" ]; then
633 # output == expected
634 good="yes"
635 echo "${test_dir}: succeeded!" 1>&2
636 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700637 fi
638fi
639
jeffhao5d1ac922011-09-29 17:41:15 -0700640(
Alex Lightbfac14a2014-07-30 09:41:21 -0700641 if [ "$good" != "yes" -a "$update_mode" != "yes" ]; then
jeffhao5d1ac922011-09-29 17:41:15 -0700642 echo "${test_dir}: FAILED!"
643 echo ' '
644 echo '#################### info'
645 cat "${td_info}" | sed 's/^/# /g'
646 echo '#################### diffs'
Ian Rogers75deec02014-11-23 20:07:39 -0800647 diff --strip-trailing-cr -u "$expected" "$output" | tail -n 2000
jeffhao5d1ac922011-09-29 17:41:15 -0700648 echo '####################'
649 echo ' '
650 fi
Alex Lightbfac14a2014-07-30 09:41:21 -0700651
652) 1>&2
653
654# Clean up test files.
655if [ "$always_clean" = "yes" -o "$good" = "yes" ]; then
656 cd "$oldwd"
657 rm -rf "$tmp_dir"
658 if [ "$target_mode" = "yes" -a "$build_exit" = "0" ]; then
659 adb shell rm -rf $DEX_LOCATION
660 fi
661 if [ "$good" = "yes" ]; then
662 exit 0
663 fi
664fi
665
666
667(
668 if [ "$always_clean" = "yes" ]; then
669 echo "${TEST_NAME} files deleted from host "
670 if [ "$target_mode" == "yes" ]; then
671 echo "and from target"
672 fi
673 else
674 echo "${TEST_NAME} files left in ${tmp_dir} on host"
675 if [ "$target_mode" == "yes" ]; then
676 echo "and in ${DEX_LOCATION} on target"
677 fi
Brian Carlstrom105215d2012-06-14 12:50:44 -0700678 fi
679
jeffhao5d1ac922011-09-29 17:41:15 -0700680) 1>&2
681
682exit 1